//  MyCommand.cs
//
//  This is a simple command called MyCommand. If you're going to
//  create a Command addin, you can start by copying this code
//  to begin your own command class.

using System;
using System.Threading;
using System.Collections.Generic;
using Do.Universe;
using Do.Addins;

namespace Do.Addins.Banshee
{

	public class BansheePlayCommand : ICommand
	{
		
		public string Name { get { 	return "Play"; 	} }
		public string Description { get { return "Play an item in Banshee."; } }
		public string Icon { get { 	return "music-player-banshee"; } }
		
		public Type[] SupportedItemTypes {
			get {
				return new Type[] {
					typeof (MusicItem),
				};
			}
		}

		public bool SupportsItem (IItem item)
		{
			return true;
		}
		
        public Type[] SupportedModifierItemTypes {
			get { return null; }
		}
        
		public bool SupportsModifierItemForItems (IItem[] items, IItem modItem)
		{
			return false;
		}
		
		public void Perform (IItem[] items, IItem[] modItems)
		{
            new Thread ((ThreadStart) delegate {
    			BansheeDBus b = new BansheeDBus();
                List<string> filenames = new List<string>();
                foreach (IItem item in items)
                {
                    foreach (SongMusicItem song in Banshee.LoadSongsFor (item as MusicItem))
                        filenames.Add(song.File);
                }
                b.Enqueue(filenames.ToArray());
            }).Start ();
		}
		
	}
}